#
# Exceptions related to network operations.
#

import timeoutsocket
import socket

timeoutsocket.setDefaultSocketTimeout(30)

def str_net_error(e):
	"""
	Python 1.5 nntplib errors are strings.
	Python 2.0 nntplib errors are class objects.
	:-(
	"""
	try:
		# Python 2.x?
		if e.args == ():
			return str(e)
		else:
			return ". ".join (map (str, e.args))
	except AttributeError:
		# Python 1.5 :-(
		return str(e)

class net_exception(Exception):
	def __init__(self, other_exception):
		try:
			self.args = other_exception.args
		except AttributeError:
			self.args = ()
	
class auth_exception(net_exception):
	pass
	
class connect_exception(net_exception):
	pass
	
class send_exception(net_exception):
	pass
	
class recv_exception(net_exception):
	pass
	
timeout_exception = (timeoutsocket.Timeout, socket.error)

